﻿Imports System
Imports System.Drawing
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Tools
Imports Syncfusion.Windows.Forms
Imports System.Drawing.Drawing2D

Namespace TextBoxExt_BackColor
	Partial Public Class Form1
		Inherits MetroForm

		#Region "Declartaion"
		'Initialzie the Close button rectangle
		Private closebutton As Rectangle
		'Initializes the LinearGradientBrush.
Private gradientBrush As LinearGradientBrush

		#End Region

		#Region "Constructor"
		Public Sub New()
			InitializeComponent()
			'tabControlAdv1.CloseButtonBackColor
			'To draw the Tab item
			AddHandler tabControlAdv1.DrawItem, AddressOf tabControlAdv1_DrawItem
			AddHandler Me.tabControlAdv1.MouseClick, AddressOf TabControlAdv1_MouseClick
			AddHandler Me.tabControlAdv1.MouseMove, AddressOf TabControlAdv1_MouseMove
		End Sub

		Private Sub TabControlAdv1_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
			For i As Integer = 0 To Me.tabControlAdv1.TabPages.Count - 1
				Dim r As Rectangle = Me.tabControlAdv1.GetTabRect(i)

				If r.Contains(e.Location) Then
					toolTip1.SetToolTip(tabControlAdv1, Me.tabControlAdv1.TabPages(i).Text)
					Exit For
				End If
			Next i
			Return
		End Sub


		Private Sub TabControlAdv1_MouseClick(ByVal sender As Object, ByVal e As MouseEventArgs)
			For i As Integer = 0 To Me.tabControlAdv1.TabPages.Count - 1
				Dim r As Rectangle = closebutton
				If closebutton.Contains(e.Location) Then
					tabControlAdv1.TabPages.Remove(tabControlAdv1.SelectedTab)
					Exit For
				End If
			Next i
		End Sub
		#End Region

		#Region "Events"
		Private Sub tabControlAdv1_DrawItem(ByVal sender As Object, ByVal drawItemInfo As DrawTabEventArgs)
			' The function GetTabRect helps to get the rectangle of the tab item.
			If drawItemInfo.Index <> Me.tabControlAdv1.SelectedIndex Then
				' For the non-selected tabs.
				gradientBrush = New System.Drawing.Drawing2D.LinearGradientBrush(Me.tabControlAdv1.GetTabRect(drawItemInfo.Index), tabControlAdv1.InactiveTabColor, tabControlAdv1.InactiveTabColor, LinearGradientMode.Horizontal)
			Else
				' For the selected tab.
				gradientBrush = New System.Drawing.Drawing2D.LinearGradientBrush(Me.tabControlAdv1.GetTabRect(drawItemInfo.Index), tabControlAdv1.ActiveTabColor, tabControlAdv1.ActiveTabColor, LinearGradientMode.Horizontal)
			End If
			Dim positions() As Single = { 0.0F, 0.05F, 0.95F, 1.0F }
			Dim factors() As Single = { 0.4F, 1.0F, 0.05F, 0.04F }
			' Blends settings.
			Dim blend As New Blend()
			blend.Factors = factors
			blend.Positions = positions
			gradientBrush.Blend = blend
			drawItemInfo.Graphics.FillRectangle(gradientBrush, Me.tabControlAdv1.GetTabRect(drawItemInfo.Index))
			gradientBrush.Dispose()

			' Draw the default borders and interior (text and image)
			drawItemInfo.DrawBorders()
			' To draw Image
			drawItemInfo.Graphics.DrawImage(Me.tabControlAdv1.TabPages(drawItemInfo.Index).Image, New Rectangle(drawItemInfo.Bounds.X + 5, drawItemInfo.Bounds.Y + 5, Me.tabControlAdv1.TabPages(drawItemInfo.Index).ImageSize.Width, Me.tabControlAdv1.TabPages(drawItemInfo.Index).ImageSize.Height))
			'To draw the text of the Tab item
			If drawItemInfo.Index <> Me.tabControlAdv1.SelectedIndex Then

				' For the non-selected tabs.  
				Dim size As Size = TextRenderer.MeasureText(Me.tabControlAdv1.TabPages(drawItemInfo.Index).Text, tabControlAdv1.ActiveTabFont)
				Dim format As New StringFormat()
				format.Trimming = StringTrimming.EllipsisCharacter
				TextRenderer.DrawText(drawItemInfo.Graphics, Me.tabControlAdv1.TabPages(drawItemInfo.Index).Text, Me.tabControlAdv1.TabPages(drawItemInfo.Index).Font, New Rectangle(drawItemInfo.Bounds.X + 25, drawItemInfo.Bounds.Y + 7, drawItemInfo.Bounds.Width - 40, drawItemInfo.Bounds.Height), Color.Black, TextFormatFlags.EndEllipsis)
			Else
				' For the selected tab.
				Dim size As Size = TextRenderer.MeasureText(Me.tabControlAdv1.TabPages(drawItemInfo.Index).Text, tabControlAdv1.ActiveTabFont)
				Dim format As New StringFormat()
				format.Trimming = StringTrimming.Character
				TextRenderer.DrawText(drawItemInfo.Graphics, Me.tabControlAdv1.TabPages(drawItemInfo.Index).Text, Me.tabControlAdv1.TabPages(drawItemInfo.Index).Font, New Rectangle(drawItemInfo.Bounds.X + 25, drawItemInfo.Bounds.Y + 7, drawItemInfo.Bounds.Width - 40, drawItemInfo.Bounds.Height), Color.Black, TextFormatFlags.EndEllipsis)


			End If
			'For Close Button 
			closebutton = New Rectangle(drawItemInfo.Bounds.X + drawItemInfo.Bounds.Width - 20, drawItemInfo.Bounds.Y + 7, 13, 13)
			'To draw the close button rectangle
			drawItemInfo.Graphics.FillRectangle(Brushes.Red, closebutton)
			' To draw "X" in Red color rectangle
			drawItemInfo.Graphics.DrawLine(New Pen(Brushes.White), New Point(closebutton.X + 4, closebutton.Y + 4), New Point(closebutton.X + closebutton.Width - 4, closebutton.Y + closebutton.Height - 4))
			drawItemInfo.Graphics.DrawLine(New Pen(Brushes.White), New Point(closebutton.X + 4, closebutton.Y - 4 + closebutton.Height), New Point(closebutton.X + closebutton.Width - 4, closebutton.Y + 4))
		End Sub

		#End Region
	End Class
End Namespace